# coding: utf-8

# flake8: noqa

"""
    BOAVIZTAPI - DEMO

    <p>🎯 Retrieving the impacts of digital elements.</p> <p>This is a quick demo, to see full documentation <a href=\"https://doc.api.boavizta.org\">click here</a></p> <h2>Features</h2> <p>Bellow a list of all available features.</p> <h3>👄 Verbose</h3> <p>Verbose is an HTTP parameter. If set at true :</p> <ul> <li>Shows the impacts of each component</li> <li>Shows the value used for each attribute</li> </ul> <p><em>\"attribute\": {\"value\": \"value\", \"unit\": \"unit\", \"status\": \"Status\", \"source\": \"Source\", \"min\":\"min\", \"max\":\"max\", \"significant_figures\":\"significant_figures\"}</em></p> <h3>🔨 Embedded</h3> <ul> <li>Embedded impacts are the impacts occurring during raw material extraction, manufacture, distribution and end of life</li> <li>When end of life is not taken into account, we specified it in the <code>warnings</code></li> </ul> <h3>🔌  Usage</h3> <p>Usage impacts are assessed by multiplying :</p> <ul> <li> <p>a <strong>duration</strong></p> </li> <li> <p>an <strong>impact factor</strong> </p> </li> <li> <p>an <strong>electrical consumption</strong> </p> </li> </ul> <h4>⏲ Duration</h4> <p>Usage impacts can be given as a router parameter, in hours.</p> <p>If no duration is given, <strong>the impact is assess for the all life duration of the asset</strong>.</p> <h4>✖️ Impact factors</h4> <ul> <li>Impact factors can be given : <em>\"usage\":{\"elec_factors\":{[criteria]: 0.38}}</em></li> <li> <p>Impact factors can be retrieved from : <em>\"usage\":{\"usage_location\": \"FRA\"}</em>. </p> </li> <li> <p>See the list of locations : <a href=\"/v1/utils/country_code\">/v1/utils/country_code</a>*</p> </li> </ul> <h4>⚡ Electrical consumption</h4> <h5>⏺️ Given</h5> <ul> <li>Electrical consumption can be given for one hour (average) <em>\"usage\":{\"avg_power\": 1}</em>.</li> </ul> <h5>📈 Modeled</h5> <ul> <li>Electrical consumption can be retrieved from consumption profile using <em>usage:{time_workload: 50}</em>.</li> </ul> <h5>📋 Archetype</h5> <ul> <li>In some cases, default electrical consumption can be taken from the archetype</li> </ul> <h3>🔃 Auto-complete &amp; 📋 Archetype</h3> <p>The API will complete the missing attributes in a request with a completion function or with values taken from the <code>archetype</code> specified in the route parameter.</p> <h3>⏬ Allocation</h3> <ul> <li>Usage impacts are assessed on the duration given in route parameter</li> <li>Embedded impacts are allocated linearly on the duration given in parameter <code>embedded_impact = impact * (duration/life_duration)</code></li> </ul> <p>If no duration is given, the life_duration (<code>`hours_life_time</code>) of the asset is used.</p>

    The version of the OpenAPI document: 1.2.4
    Generated by OpenAPI Generator (https://openapi-generator.tech)

    Do not edit the class manually.
"""  # noqa: E501


__version__ = "1.0.0"

# import apis into sdk package
from boaviztapi_sdk.api.cloud_api import CloudApi
from boaviztapi_sdk.api.component_api import ComponentApi
from boaviztapi_sdk.api.consumption_profile_api import ConsumptionProfileApi
from boaviztapi_sdk.api.default_api import DefaultApi
from boaviztapi_sdk.api.iot_api import IotApi
from boaviztapi_sdk.api.peripheral_api import PeripheralApi
from boaviztapi_sdk.api.server_api import ServerApi
from boaviztapi_sdk.api.terminal_api import TerminalApi
from boaviztapi_sdk.api.utils_api import UtilsApi

# import ApiClient
from boaviztapi_sdk.api_response import ApiResponse
from boaviztapi_sdk.api_client import ApiClient
from boaviztapi_sdk.configuration import Configuration
from boaviztapi_sdk.exceptions import OpenApiException
from boaviztapi_sdk.exceptions import ApiTypeError
from boaviztapi_sdk.exceptions import ApiValueError
from boaviztapi_sdk.exceptions import ApiKeyError
from boaviztapi_sdk.exceptions import ApiAttributeError
from boaviztapi_sdk.exceptions import ApiException

# import models into sdk package
from boaviztapi_sdk.models.box import Box
from boaviztapi_sdk.models.cpu import CPU
from boaviztapi_sdk.models.case import Case
from boaviztapi_sdk.models.cloud import Cloud
from boaviztapi_sdk.models.configuration_server import ConfigurationServer
from boaviztapi_sdk.models.consumption_profile_cpu import ConsumptionProfileCPU
from boaviztapi_sdk.models.desktop import Desktop
from boaviztapi_sdk.models.disk import Disk
from boaviztapi_sdk.models.elec_factors import ElecFactors
from boaviztapi_sdk.models.external_hdd import ExternalHDD
from boaviztapi_sdk.models.external_ssd import ExternalSSD
from boaviztapi_sdk.models.functional_block import FunctionalBlock
from boaviztapi_sdk.models.http_validation_error import HTTPValidationError
from boaviztapi_sdk.models.io_t import IoT
from boaviztapi_sdk.models.laptop import Laptop
from boaviztapi_sdk.models.location_inner import LocationInner
from boaviztapi_sdk.models.model_server import ModelServer
from boaviztapi_sdk.models.monitor import Monitor
from boaviztapi_sdk.models.motherboard import Motherboard
from boaviztapi_sdk.models.power_supply import PowerSupply
from boaviztapi_sdk.models.ram import RAM
from boaviztapi_sdk.models.server import Server
from boaviztapi_sdk.models.smartphone import Smartphone
from boaviztapi_sdk.models.tablet import Tablet
from boaviztapi_sdk.models.television import Television
from boaviztapi_sdk.models.time_workload import TimeWorkload
from boaviztapi_sdk.models.usage import Usage
from boaviztapi_sdk.models.usage_cloud import UsageCloud
from boaviztapi_sdk.models.usage_server import UsageServer
from boaviztapi_sdk.models.usb_stick import UsbStick
from boaviztapi_sdk.models.validation_error import ValidationError
from boaviztapi_sdk.models.workload_power import WorkloadPower
from boaviztapi_sdk.models.workload_time import WorkloadTime
